bzoj1015题解

【题意分析】

  给你一张无向图,要求支持删点和询问连通块数。

【解题思路】

  可以直接可持久化并查集大力艹过去。

  考虑到正着删点就是倒着加点,所以并不需要可持久化。复杂度O((k+m)α(n))。

【参考代码】

  当时还在玩泥巴,实现有点naive,常数奇大无比。。

 1 #include<cstdio>
 2 #include<cstring>
 3 #include<set>
 4 #define REP(I,start,end) for(int I=start;I<=end;I++)
 5 #define PER(I,start,end) for(int I=start;I>=end;I--)
 6 using namespace std;
 7 set<int> tree;
 8 int n,m,k,edge=0,q[400001],father[400001],head[400001],next[400001],point[400001],sav[400001];
 9 bool destroyed[400001];
10 inline void addEdge(int from,int to)
11 {
12     next[++edge]=head[from];
13     head[from]=edge;
14     point[edge]=to;
15 }
16 inline int getFa(int n)
17 {
18     if(father[n]==n)
19         return n;
20     return father[n]=getFa(father[n]);
21 }
22 int main()
23 {
24     scanf("%d%d",&n,&m);
25     REP(i,1,m)
26     {
27         int u,v;
28         scanf("%d%d",&u,&v);
29         addEdge(u,v);
30         addEdge(v,u);
31     }
32     scanf("%d",&k);
33     memset(destroyed,0,sizeof(destroyed));
34     REP(i,1,k)
35     {
36         scanf("%d",q+i);
37         destroyed[q[i]]=true;
38     }
39     REP(i,0,n-1)
40         father[i]=i;
41     REP(i,0,n-1)
42         if(!destroyed[i])
43         {
44             int t=head[i];
45             while(t)
46             {
47                 int p=point[t];
48                 if(!destroyed[p])
49                     father[getFa(p)]=getFa(i);
50                 t=next[t];
51             }
52         }
53     tree.clear();
54     REP(i,0,n-1)
55     {
56         int fa=getFa(i);
57         if(!destroyed[i]&&tree.find(fa)==tree.end())
58             tree.insert(fa);
59     }
60     sav[k]=tree.size();
61     PER(i,k-1,0)
62     {
63         int P=q[i+1],t=head[P];
64         destroyed[P]=false;
65         tree.clear();
66         while(t)
67         {
68             int p=point[t];
69             if(!destroyed[p])
70             {
71                 int fa2=getFa(p);
72                 tree.insert(fa2);
73                 father[getFa(P)]=fa2;
74             }
75             t=next[t];
76         }
77         sav[i]=sav[i+1]-tree.size()+1;
78     }
79     REP(i,0,k)
80         printf("%d\n",sav[i]);
81     return 0;
82 }

时间: 2024-10-21 18:12:05

bzoj1015题解的相关文章

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

BZOJ1015[JSOI2008]星球大战starwar[并查集]

1015: [JSOI2008]星球大战starwar Time Limit: 3 Sec  Memory Limit: 162 MBSubmit: 5253  Solved: 2395[Submit][Status][Discuss] Description 很久以前,在一个遥远的星系,一个黑暗的帝国靠着它的超级武器统治者整个星系.某一天,凭着一个偶然的机遇,一支反抗军摧毁了帝国的超级武器,并攻下了星系中几乎所有的星球.这些星球通过特殊的以太隧道互相直接或间接地连接. 但好景不长,很快帝国又重

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ